SkillWin = createRussianWindow();
SkillWin:SetSize(800,600);
SkillWin:SetOpacity(1);
SkillWin:SetPosition(settings.SkillWin_X, settings.SkillWin_Y);
SkillWin:SetBackground(vResPath.."BackGr.tga");
SkillWin:rusSetText(_G.Captions.SkillWin);
SkillWin:SetVisible(false);
SkillWin:SetWantsKeyEvents(true);
SkillWin.KeyDown = function(sender, args)
  if args.Action == Turbine.UI.Lotro.Action.Escape then
    SkillWin:SetVisible(false)
  end;
end;
SkillWin.PositionChanged = function(sender, args)
  settings.SkillWin_X = string.format("%.0f", SkillWin:GetLeft());
  settings.SkillWin_Y = string.format("%.0f", SkillWin:GetTop());        
  SaveSettings();
end;

trwSkill = Turbine.UI.Window();
trwSkill:SetParent(SkillWin);
trwSkill:SetSize(770, 70);
trwSkill:SetPosition(15, 40);
trwSkill:SetBackground(vResPath.."Skills/TopRegion.tga");
trwSkill:SetVisible(true);

import (vLocalePath.."Skills");

lbClasses = Turbine.UI.ListBox();
lbClasses:SetParent(trwSkill);
lbClasses:SetOpacity(1);
lbClasses:SetPosition(70, 3);
lbClasses:SetSize(690, 64);
lbClasses:SetMaxItemsPerLine(1);
lbClasses:SetOrientation(Turbine.UI.Orientation.Vertical);
lbClasses.currItem = 0;
lbClasses:ClearItems();

lrwSkill = Turbine.UI.Window();
lrwSkill:SetParent(SkillWin);
lrwSkill:SetSize(280, 460);
lrwSkill:SetPosition(15, 115);
lrwSkill:SetBackground(vResPath.."Skills/LeftRegion.tga");
lrwSkill:SetVisible(true);

lbGroups = Turbine.UI.ListBox();
lbGroups:SetParent(lrwSkill);
lbGroups:SetOpacity(1);
lbGroups:SetPosition(7, 7);
lbGroups:SetSize(273, 453);
lbGroups:SetMaxItemsPerLine(1);
lbGroups:SetOrientation(Turbine.UI.Orientation.Horizontal);
lbGroups.currItem = nil;

rrwSkill = Turbine.UI.Window();
rrwSkill:SetParent(SkillWin);
rrwSkill:SetSize(474, 460);
rrwSkill:SetPosition(310, 115);
rrwSkill:SetBackground(vResPath.."Skills/RightRegion.tga");
rrwSkill:SetVisible(true);

lbSkills = Turbine.UI.ListBox();
lbSkills:SetParent(rrwSkill);
lbSkills:SetOpacity(1);
lbSkills:SetPosition(7, 7);
lbSkills:SetSize(450, 451);
lbSkills:SetMaxItemsPerLine(1);
lbSkills:SetOrientation(Turbine.UI.Orientation.Horizontal);
lbSkills.currItem = nil;

lbSkillsSB = Turbine.UI.Lotro.ScrollBar();
lbSkillsSB:SetOrientation(Turbine.UI.Orientation.Vertical);
lbSkillsSB:SetParent(rrwSkill);
lbSkillsSB:SetPosition(lbSkills:GetWidth()+lbSkills:GetLeft(), lbSkills:GetTop());
lbSkillsSB:SetSize(10, lbSkills:GetHeight());

lbSkills:SetVerticalScrollBar(lbSkillsSB);

local lenSkills = #_G.Skills;
for i = 1, lenSkills do
  local lItem = Turbine.UI.Label();
  lItem:SetSize(64, 64);
  lItem:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
  
  lItem.Button = Turbine.UI.Button();
  lItem.Button:SetParent(lItem);
  lItem.SkillsNum = i;
  lItem.Button:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
  lItem.Button:SetSize(64, 64);
  lItem.Button:SetBackground(vResPath.."Skills/".._G.Skills[i].IconName..".tga");
  lItem.Button.Click = function(sender, args)
    if lbClasses.currItem ~= 0 then
      lbClasses:GetItem(lbClasses.currItem):SetBackground(vResPath.."Skills/None.tga")
    end;
    sender:GetParent():SetBackground(vResPath.."Skills/Select.tga");
    lbClasses.currItem = sender:GetParent().SkillsNum;
    lbSkills:ClearItems();
    ResetSkillPanel();
  end;                                      
  lItem.Button.MouseEnter = function(sender, args)
    sender:SetBackground(vResPath.."Skills/".._G.Skills[i].IconName.."_h.tga")
  end;
  lItem.Button.MouseLeave = function(sender, args)
    sender:SetBackground(vResPath.."Skills/".._G.Skills[i].IconName..".tga")
  end;
  lItem.Button.MouseDown = function(sender, args)
    sender:SetBackground(vResPath.."Skills/".._G.Skills[i].IconName.."_d.tga")
  end;
  lItem.Button.MouseUp = function(sender, args)
    sender:SetBackground(vResPath.."Skills/".._G.Skills[i].IconName.."_h.tga")
  end;
  lbClasses:AddItem(lItem);
end;
 
function ResetSkillPanel()
  if currItem == 0 then
    return;
  end;  
  lbGroups:ClearItems();
  GropList = {[1] = _G.Skills[lbClasses.currItem].SkillGroups,
              [2] = _G.Skills[lbClasses.currItem].TraitGroups,
              [3] = _G.Skills[lbClasses.currItem].TraitBonusGroups
  };
  GroupCaptionList = {
              [1] = _G.SkillsCaption,
              [2] = _G.TraitCaption,
              [3] = _G.TraitBonusCaption
  };
  GroupResetInfo = {
              [1] = ResetSkillInfo,
              [2] = ResetSkillInfo,
              [3] = ResetSkillInfo
  };              
  for g =1, 3 do
    local Item = Turbine.UI.Label();
    Item:SetSize(250, 16);
    Item:SetFont(Turbine.UI.Lotro.Font.Verdana18);
    Item:SetForeColor(_G.clShadowWhite);
    Item:SetText(GroupCaptionList[g]);
    local numGroups = #GropList[g];
    lbGroups:AddItem(Item);
    for i = 1, numGroups do
      local Item = Turbine.UI.Button();
      Item:SetSize(250, 16);
      Item:SetFont(Turbine.UI.Lotro.Font.Verdana14);
      Item:SetForeColor(_G.clShadowWhite);
      Item:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
      Item:SetText("     "..GropList[g][i].GroupName);
      Item.Groups = i;
      Item.Click = function(sender, args)
        if lbGroups.currItem ~= nil then
          lbGroups.currItem:SetForeColor(_G.clShadowWhite);
        end;
        sender:SetForeColor(_G.clNiceGreen);
        lbGroups.currItem = sender;
        GroupResetInfo[g](g);
      end;
      lbGroups:AddItem(Item);
    end;
  end;  
end;

function ResetSkillInfo(g)
  lbSkills:ClearItems();
  local arSkills = {};
  if g == 1 then
    arSkills = _G.Skills[lbClasses.currItem].SkillGroups[lbGroups.currItem.Groups].Skills;
  elseif g == 2 then
    arSkills = _G.Skills[lbClasses.currItem].TraitGroups[lbGroups.currItem.Groups].Traits;
  elseif g == 3 then
    arSkills = _G.Skills[lbClasses.currItem].TraitBonusGroups[lbGroups.currItem.Groups].Traits;
  end;
  local numSkills = #arSkills;                   
  for i=1, numSkills do 
    local Item = Turbine.UI.Control();
    Item:SetParent(lbSkills);
    Item:SetSize(450, 115);
    if g > 1 then
      Item.CaptionColor = Turbine.UI.Control();
      Item.CaptionColor:SetParent(Item);
      Item.CaptionColor:SetSize(450, 41);
      Item.CaptionColor:SetPosition(0, 1);
      Item.CaptionColor:SetBackColor(arSkills[i].Color);      
      
      Item.CaptionColorLeft = Turbine.UI.Control();
      Item.CaptionColorLeft:SetParent(Item);
      Item.CaptionColorLeft:SetSize(2, 70);
      Item.CaptionColorLeft:SetPosition(0, 42);
      Item.CaptionColorLeft:SetBackColor(arSkills[i].Color);      
      
      Item.CaptionColorBottom = Turbine.UI.Control();
      Item.CaptionColorBottom:SetParent(Item);
      Item.CaptionColorBottom:SetSize(450, 2);
      Item.CaptionColorBottom:SetPosition(0, 110);
      Item.CaptionColorBottom:SetBackColor(arSkills[i].Color);      
      
      Item.CaptionColorRight = Turbine.UI.Control();
      Item.CaptionColorRight:SetParent(Item);
      Item.CaptionColorRight:SetSize(2, 70);
      Item.CaptionColorRight:SetPosition(448, 42);
      Item.CaptionColorRight:SetBackColor(arSkills[i].Color);
    end;
    if tonumber(arSkills[i].ID) > 1870000000 then
      Item.QS = Turbine.UI.Lotro.Quickslot(); 
      Item.QS:SetSize(36, 36);
      Item.QS:SetShortcut(Turbine.UI.Lotro.Shortcut(6.0, arSkills[i].ID));
      Item.QS:SetEnabled(arSkills[i].ReadOnly);
      Item.QS:SetAllowDrop(arSkills[i].ReadOnly ~= nil and arSkills[i].ReadOnly ~= true);
      Item.QS:SetUseOnRightClick(arSkills[i].ReadOnly ~= nil and arSkills[i].ReadOnly ~= true);
    else
      Item.QS = Turbine.UI.Label();
      Item.QS:SetSize(32, 32);
      if g == 3 and i == 1 then
        Item.QS:SetBackground(vResPath.."Skills/Hero.tga");
      else  
        Item.QS:SetBackground(arSkills[i].ID);
      end;  
    end;                                           
    Item.QS:SetParent(Item);
    Item.QS:SetPosition(1, 1);
    
    Item.Name = Turbine.UI.Label();
    Item.Name:SetParent(Item);
    Item.Name:SetSize(270, 36);
    Item.Name:SetPosition(40, 1);
    if string.len(arSkills[i].Name) > 54 then
      Item.Name:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    else
      Item.Name:SetFont(Turbine.UI.Lotro.Font.Verdana18);
    end  
    Item.Name:SetForeColor(_G.clShadowWhite);
    Item.Name:SetText(arSkills[i].Name);
    
    Item.Name_en = Turbine.UI.Label();
    Item.Name_en:SetParent(Item);
    Item.Name_en:SetSize(270, 12);
    Item.Name_en:SetPosition(40, 28);
    Item.Name_en:SetFont(Turbine.UI.Lotro.Font.Verdana12);
    Item.Name_en:SetForeColor(_G.clGray);
    Item.Name_en:SetText(arSkills[i].Name_en);
    
    Item.Cond = Turbine.UI.Label();
    Item.Cond:SetParent(Item);
    Item.Cond:SetSize(135, 36);
    Item.Cond:SetPosition(310, 1);
    Item.Cond:SetFont(Turbine.UI.Lotro.Font.Verdana12);
    Item.Cond:SetForeColor(_G.clGray);
    if arSkills[i].CondTakes ~= nil then 
      Item.Cond:SetText(_G.SkillsCond..arSkills[i].CondTakes);
    end;  
    
    Item.Descr = Turbine.UI.Label();
    Item.Descr:SetParent(Item);
    Item.Descr:SetSize(436, 63);
    Item.Descr:SetPosition(3, 42);
    Item.Descr:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    Item.Descr:SetForeColor(_G.clShadowWhite);
    Item.Descr:SetText(arSkills[i].Description);
    
    Item.DescrSB = Turbine.UI.Lotro.ScrollBar();
    Item.DescrSB:SetOrientation(Turbine.UI.Orientation.Vertical);
    Item.DescrSB:SetParent(Item);
    Item.DescrSB:SetPosition(Item.Descr:GetWidth()+Item.Descr:GetLeft(), Item.Descr:GetTop());
    Item.DescrSB:SetSize(10, Item.Descr:GetHeight());

    Item.Descr:SetVerticalScrollBar(Item.DescrSB);
    
    lbSkills:AddItem(Item);
  end;
end;
function ResetTraitInfo()
end;
function ResetTraitBonusInfo()
end;
